#include <termios.h>
#include <unistd.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>

#define TRUE 1
#define FALSE 0
#define NB_CARACTERES 20	// taille de la lignes
#define TIME_TO_WAIT 120000	// temps d'attente

typedef struct termios termios;
static void handler();		
static int test,pfd[2];		//dfinition des variables qui pourront 
static char lettre;		//tre utilises par toutes les fonctions

void my_printf(char chaine)	//fonction permettant de raliser un dlai entre chaque caractre
{							// afficher
	printf("%c",chaine);
	fflush(stdout);
	usleep(TIME_TO_WAIT);
}

/*
	affiche les crochets
*/
void prepareAffichage()
{
	int i;
	printf("[");
	for(i=0; i<NB_CARACTERES; i++)
		printf(" ");
	printf("]\b");
	for(i=0; i<NB_CARACTERES; i++)
		printf("\b");
}


int pong(char argv)
{

	int j, i;
	
		// affiche les crochets
		prepareAffichage();
		// Allez
		for(i=0; i<NB_CARACTERES; i++)
			my_printf(argv);
			my_printf(']');
		// Retour
		for(i=0; i<NB_CARACTERES; i++)
		{
			printf("%c",'\b');
			printf("%c",'\b');
			my_printf(' ');
		}
		printf("\b\b");

	return 0;
}


void handler()
{
	read(pfd[0],&lettre,1);	
	return;
}

int main()
{
	lettre='-';
	termios t_save, t_new;
	struct sigaction action;
	test=0;
	if( tcgetattr(0, &t_save) )
	{
		printf("Erreur de tcgetattr !\n");
		exit(1);
	}

	// initialisation
	t_new = t_save;
	t_new.c_lflag &= (~ICANON & ~ECHO);
	t_new.c_cc[VMIN]= 1;

	tcsetattr(0, TCSANOW, &t_new);
	int quit = FALSE,car;
	int n;
	pipe(pfd);
	n=fork();
	//char * lecture;
	int fils,statut;
	if(n==0)  //dans le fils
	{
		while(1)
		{
			close(pfd[1]);
			action.sa_handler = handler;
			//sigaction(SIGUSR1, &action, NULL);
			int j, i;
	
			// affiche les crochets
			prepareAffichage();
			// Allez
			for(i=0; i<NB_CARACTERES; i++)
			{
				my_printf(lettre);
				sigaction(SIGUSR1, &action, NULL);
			}
			my_printf(']');
			// Retour
			for(i=0; i<NB_CARACTERES; i++)
			{
				printf("%c",'\b');
				printf("%c",'\b');
				my_printf(' ');
				sigaction(SIGUSR1, &action, NULL);
			}
		printf("\b\b");

			if (lettre=='f')
			{
				printf("\nfin du fils\n");
				exit(1);
			}
		}

	}
	else		//dans le pere
	{
		close(pfd[0]);
		while(!quit)
		{
			car = getchar();
			write(pfd[1],&car,1); 
			if (car == 'f') quit = TRUE;
			kill(n,SIGUSR1);/* envoie SIGUSR1 a son fils */
		}
		fils=wait(&statut);
		if (WIFEXITED(statut))
		{
		printf("\nfin du pere\n");
		exit(1);
		}
	}
	tcsetattr(0, TCSANOW, &t_save);
	return 0;
}

