#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/mman.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#define TAILLE 5

/* strucure de trois entiers */
typedef struct vector {
	int X;
	int Y;
	int Z;} vector;

/* strucure d'un vecteur et d'une adresse de vecteur */
typedef struct data_vector {
	vector v;
	vector* adr; } data_vector;

/* fonction d'affichage de la structure */
void imprimeVector(vector * v)
{
	if (v)
		printf("%d %d %d\n", v->X, v->Y, v->Z);
	else
		printf("Error...\n");
}


int main()
{
	// initialisation de v 
	vector v[TAILLE];
		v[0].X = 1; v[0].Y = 2; v[0].Z = 3;
		v[1].X = 5; v[1].Y = 4; v[1].Z = 5;
		v[2].X = 6; v[2].Y = 6; v[2].Z = 7;
		v[3].X = 7; v[3].Y = 8; v[3].Z = 9;
		v[4].X = 4; v[4].Y = 0; v[4].Z = 1;

	
struct shmid_ds buf;
	// allocation d'une zone de mmoire partage
	int shmid=shmget(ftok("",78), TAILLE*sizeof(data_vector), 0777|IPC_CREAT);
	data_vector * buffer = shmat(shmid, NULL, 0);

	// initialisation du buffer
	int i=0;
	for(;i<TAILLE;i++)
	{
		buffer[i].v = v[i];
		buffer[i].adr = &v[i];
	}
	
	// affichages 
	for(i=0;i<TAILLE;i++)
		printf("\t%d", &v[i]);
	printf("\n");

	// affichages 
	for(i=0;i<TAILLE;i++)
		imprimeVector(&v[i]);

	printf("\n%d\n", buffer);
	for(i=0;i<TAILLE;i++)
		imprimeVector(&buffer[i].v);
	for(i=0;i<TAILLE;i++)
		printf("\t%d", buffer[i].adr);
	printf("\n");

	// attendre 10 secondes
	usleep(10000000);

	// fermer la zone de mmoire partage
	shmctl(shmid, IPC_RMID,0);
	printf("fin du fichier d'ecriture\n");
	return 0;
}



