#include <stdlib.h>
#include <stdio.h>
#include <sys/file.h>
#include <fcntl.h>
#include <unistd.h>
#include <assert.h>

#define NOM_FICHIER "lockedFile.txt"

#define PARAM_STRT 0
#define PARAM_SIZE 1
#define PARAM_MODE 2

/* Gestion des erreurs : affichage + exit */
void erreur(char *c)
{
	perror(c);
	exit(EXIT_FAILURE);
}



int main(int argc,char **argv)
{
	int fic, i, j;
	short mode;
	struct flock lck;
	int param[3];

	/* on verifie le nb d'arguments */
	assert((argc%3) == 1);


	printf("poser %d verrou(s)\n", argc/3);


	/* ouverture du fichier */
	if ((fic = open(NOM_FICHIER, O_RDWR)) == -1)
		erreur("ouverture");

	/* boucle de parcours */
	for(i=0; i<argc/3; i++)
	{
		/* Récup des paramètres */
		for(j=0; j<3; j++)
			param[j] = atoi(argv[i*3+1+j]);

		/* initilisation de lck */
		lck.l_type   = (param[PARAM_MODE]==1) ? F_RDLCK: F_WRLCK;
		lck.l_whence = SEEK_SET;
		lck.l_start  = param[PARAM_STRT];
		lck.l_len    = param[PARAM_SIZE];

		printf("a %d pour %d type %d\n", param[0], param[1], param[2]);
		if (fcntl(fic, F_GETLK, &lck))
		{
			printf("non pour %d %d %d\n",
				param[0], param[1], param[2]);
		}
		else
		{
			printf("oui pour %d %d %d\n",
				param[0], param[1], param[2]);
		}

/*
		if (lck.l_type == F_UNLCK)
		{
			lck.l_type = mode;*/
			if (fcntl(fic, F_SETLK, &lck))
			{
				erreur("pose verrou");
			}
			else
			{
				printf("oui pour %d %d %d\n",
					param[0], param[1], param[2]);
			}
			//while(1);
/*
		}
		else
		{
			switch (lck.l_type)
			{
				case F_RDLCK : printf("verrou partagé posé par %d\n", lck.l_pid); break;
				case F_WRLCK : printf("verrou exclusif posé par %d\n", lck.l_pid); break;
			}
			printf("intervalle bloqué : [%d,%d[\n", lck.l_start, lck.l_start+lck.l_len);
		}
*/
	}
	return 0;
}
