#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/uio.h>
#include <signal.h>
#include <unistd.h>
#include <stdio.h>
#include <time.h>
#include <fcntl.h>
#include <errno.h>

#define CHAR_64 "012465789012465789012465789012465789012465789012465789abc\n"
#define STRING_SIZE 64
#define SIZE_BITE_TO_KBYTE 1024
#define FICHIER "./megas.txt"
#define TPS_ALRM 100000

int sigStop=0;
int sigcount=0;

void catcher( int sig )
{
    struct itimerval value;
    int which = ITIMER_REAL;

    //printf( "[catcher]Signal : %d\n", sig );
    sigcount++;
    if(sigStop)
    {
        getitimer( which, &value );
        setitimer( which, &value, NULL );
    }
}

int main()
{
    int n, fd, i;
    int result = 0;
    struct itimerval value, ovalue, pvalue;
    int which = ITIMER_REAL;
    struct sigaction sact;
    time_t t_deb=time(NULL), t_fin=time(NULL);

    sigemptyset( &sact.sa_mask );
    sact.sa_flags = 0;
    sact.sa_handler = catcher;
    sigaction( SIGALRM, &sact, NULL );
    getitimer( which, &pvalue );


    // taille du fichier à créer
    printf("Taille du fichier a creer : ");
    scanf("%d", &n);
    n = n * SIZE_BITE_TO_KBYTE * SIZE_BITE_TO_KBYTE;


    /*
     * Défini un timer en millisecondes
     */
    value.it_interval.tv_sec = 0;
    value.it_interval.tv_usec = TPS_ALRM;
    value.it_value.tv_sec = 0;
    value.it_value.tv_usec = TPS_ALRM;

    result = setitimer( which, &value, &ovalue );


    time( &t_deb );

    /* Notre partie */
    fd=open (FICHIER,O_WRONLY|O_CREAT,0777);
    if (fd==-1) perror("open");

    for(i=0; i<n/STRING_SIZE; i++)
        write(fd, &CHAR_64, STRING_SIZE);
    close(fd);


    // On demande à l'alarme de s'arréter
    sigStop = 1;
    
    // on attend la fin de l'alarme
    time( &t_fin );


    //printf( "After loop, time is %s\n", ctime(&t) );


    printf( "Count : %d\n", sigcount );
    printf( "Temps : %d secondes\n", (t_fin - t_deb) );


    return( result );
}


