/* thx.c exemple threads+X11 
 * appelle routines definies dans thw.c et barx.c
 * > gcc -c barx.c
 * > gcc -c thw.c
 * > gcc -o exe ex3.c thw.o barx.o -L/usr/X11R6/lib/ -lX11 -lpthread 
 */

/* main lance des threads qui chacun: 
 * 	fait progresser un rectangle horizontal,
 */
         
#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <signal.h>
#include <pthread.h>
#include <string.h>
         
/* ---------------------------------------------------- */

#define NTH 3	/* nbre de threads a lancer */
#define ifer(is,mess) if (is==-1) perror(mess)
pthread_t threads[NTH];
int tab[NTH] = {20,35,28};         

int total = 0;

pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t event;



void *th_fonc (void *arg)
{
	int numero, i, max;
	numero = (int)arg;
	max = tab[numero];
	char format[10];
	sprintf(format, " thread %d", numero);

	drawrec (100, 100+40*numero, 1+max*12, 30);
	drawstr (30, 120+40*numero, format, strlen(format));

	for (i=0;i<=max;i++)
	{
		/* la fonction usleep est thread-safe,
			donc on peut l'utiliser sans soucis */
		usleep(5000*  (20+(int) (80.0*rand()/(RAND_MAX+1.0))) );
		fillrec (101, 101+40*numero, i*12, 29,"yellow");
		flushdis ();
	}
	pthread_mutex_lock(&mutex);
	total += max;
	pthread_mutex_unlock(&mutex);

	return ((void *)(numero+100));
}


int main()
{
	srand(getpid());
	int is, i;
	void *val=0;

	initrec();


	/* créer les threads */
	for(i=0; i<NTH; i++)
	{
		printf("ici main, creation thread %d\n",i);
		is = pthread_create( &threads[i], NULL,
				th_fonc, (void *)i );
		ifer (is,"err. création thread");
	}

	/* attendre fin des threads */
	for(i=0; i<NTH; i++)
	{ 
		is = pthread_join( threads[i], &val);
		ifer (is,"err. join thread");
		printf("ici main, fin thread %d\n",((int)val-100));
	}

	printf("main : recu = %d\n", total);	

	detruitrec();	/* detruire la fenetre rectangle */
	exit(EXIT_SUCCESS); 
	return 0;
}
