/* mtk.c  : mini toolkit Xlib: widget bouton avec callbacks
 * creation d'un rectangle + gestion clic
 * compil :	gcc -c mx.c
 *		gcc -c mtk.c
 * puis : gcc -o wid1 wid1.c mtk.o mx.o -L/usr/X11R6/lib -lX11
 */

#include <stdio.h>	/* pour printf() */
#include <stdlib.h>	/* pour EXIT_FAILURE EXIT_SUCCESS */
#include <X11/Xlib.h>	/* pour Expose ButtonPress ... */

#define red     0
#define green   1
#define blue    2
#define yellow  3
#define white   4
#define black   5

/*--- structure de donnes pour stocker adresses des callbacks ---*/
#define N_WIDGET (20)
typedef struct
{ int typ, x, y, l, h;
  int (*pfunc)(); char *name; } Typewidget;
Typewidget Widgets[N_WIDGET];
int Nbwid = 0;
int typb = 1;	/* type button - distinguer les types de widgets */
int larb = 90;	/* lar et htr des boutons */
int htrb = 50;
int typc = 2;	/* type canvas - distinguer les types de widgets */

/* ---------------------- fonctions du mini-toolkit --------------- */

int initbut (int x, int y, char *txt) {
	int n;
	drawrec(x,y,larb,htrb,black); /* rectangle x,y -- larg,hter */
	drawstr(x+5,y+10,txt,strlen(txt),black); /* crire texte */
	printf("init button at x,y=%d %d Nbwid=%d\n",x,y,Nbwid);
	Widgets[Nbwid].typ = typb;
	Widgets[Nbwid].x = x;
	Widgets[Nbwid].y = y;
	Widgets[Nbwid].l = larb;
	Widgets[Nbwid].h = htrb;
	Widgets[Nbwid].name = txt;
	n=Nbwid; Nbwid++;
	return n;
}
void setbutcbk (int numwid, int (*pfunc)() ) {
	Widgets[numwid].pfunc = pfunc;
}

int initcanv (int x, int y, int larg, int hter) {
	int n;
        drawrec(x,y,larg,hter,black); /* rectangle x,y -- larg,hter */
        printf("init canv at x,y=%d %d Nbwid=%d\n",x,y,Nbwid);
        Widgets[Nbwid].typ = typc;
        Widgets[Nbwid].x = x;
        Widgets[Nbwid].y = y;
        Widgets[Nbwid].l = larg;
        Widgets[Nbwid].h = hter;
        Widgets[Nbwid].name = " ";
        n=Nbwid; Nbwid++;
        return n;
}
void setcanvcbk (int numwid, int (*pfunc)() ) {
	Widgets[numwid].pfunc = pfunc;
}

int traiter_clic(int x, int y) {
	int i;
	printf("traiter_clic : clic en x,y=%d %d\n",x,y);
	/* clic dans quel widget ? */
	for (i=0 ; i<Nbwid ; i++) {
	if ( x>Widgets[i].x && y>Widgets[i].y && 
	     x<(Widgets[i].x+Widgets[i].l) && 
	     y<(Widgets[i].y+Widgets[i].h) ) return i;	
	}
	return -1;
}
void redrawid() { /* redessiner les widgets - appele si event "Expose" */
    int i;
    for (i=0 ; i<Nbwid ; i++) {
	drawrec(Widgets[i].x,Widgets[i].y,Widgets[i].l,Widgets[i].h,black);
	/* printf("Widgets[i].name= %s\n",Widgets[i].name); */
	drawstr(Widgets[i].x+5,Widgets[i].y+10,
		Widgets[i].name,strlen(Widgets[i].name),black);/* */
    }
}

mtkloop ()			/* mtk main event loop */
/* called ONCE by the app. never return; call callbacks on events */
/* liste des events dans /usr/include/X11/X.h  */
{
	int event,x,y,key , x0,y0,x1,y1,i;
	char c;

	while (1) {
	nextevent (&event, &x, &y, &key, &c); /* get next X event */
	/* printf("aprs nexevent x,y=%d %d\n",x,y); */
	  switch (event) {
	        case Expose:
			printf("expose redraw\n");
	                redraw (); /* the app must provide a redraw func */
			redrawid(); /* redraw registered widgets */
	                break;
	        case MotionNotify:
        	        i = traiter_clic (x, y);
			if (i>=0) {
			  if (Widgets[i].typ == typc )
			  	Widgets[i].pfunc(event,x,y);
			}
	                break;
	        case ButtonPress:
        	        i = traiter_clic (x, y);
			if (i>=0) {
				printf("clic dans widget %d\n",i);
			  	Widgets[i].pfunc(event,x,y);
			} else {
				printf("clic outside widgets\n");
			}
			break;
	        case ButtonRelease:
        	        i = traiter_clic (x, y);
			if (i>=0) {
				printf("clic dans widget %d\n",i);
			  	Widgets[i].pfunc(event,x,y);
			} else {
				printf("clic outside widgets\n");
			}
			break;
		default :
			printf("get event %d\n",event);
	  } /* fin switch */
	} /* fin while(1) */
	printf("should never go here\n");
} /* fin mtkloop */
