/* wid1.c  exemple xlib : utilise mini-toolkit mtk.c + mx.c
 * compil : 	gcc -c mx.c
 *		gcc -c mtk.c
 * sur linux :	gcc -o wid1 wid1.c mtk.o mx.o -L/usr/X11R6/lib -lX11
 * solaris :	gcc -o wid1 wid1.c mtk.o mx.o -lX11
 */

#include <stdio.h>	/* pour printf() */
#include <signal.h>	/* pour signal() */
#include <unistd.h>	/* pour pause() */
#include <stdlib.h>	/* pour EXIT_FAILURE EXIT_SUCCESS */
#include <X11/Xlib.h>	/* pour Expose ButtonPress ... */

#define red     0
#define green   1
#define blue    2
#define yellow  3
#define white   4
#define black   5

extern int larb,htrb;	/* dfinis dans mtk.c */
/*--- structure de donnes pour stocker lignes dessines ---*/
#define N_LIGNES (20)
typedef struct
{ int x1, y1, x2, y2; } Typeligne;
Typeligne Lignes[N_LIGNES];
int Nblignes = 0, iic=0;

/* ------------------------- fonctions callback ------------------- */

void fb1(int ev, int x, int y) {	/* callback for button 1 */
	printf("but1 clicked\n");
	fillrec(15,155,larb,htrb,yellow);
}
void fb2(int ev, int x, int y) {	/* callback for button 2 */
	printf("but2 clicked\n");
	fillrec(15,155,larb,htrb,green);
}
void fb3(int ev, int x, int y) {	/* callback for button 3 */
	printf("but3 clicked - sortir\n");
	fillrec(15,155,larb,htrb,red); flushfx ();
	sleep(2); detruitfx();
	exit(EXIT_SUCCESS);
}
void cvbk(int ev, int x, int y) {	/* callback for canvas */
    printf("click in canvas\n");
    if (ev==ButtonPress) { /* only on clic */
    	if (Nblignes>=N_LIGNES) Nblignes=0;
	if (iic==0) {	Lignes[Nblignes].x1 = x;
			Lignes[Nblignes].y1 = y; iic=1;
	} else {	Lignes[Nblignes].x2 = x;
			Lignes[Nblignes].y2 = y; iic=0;
	drawvec(Lignes[Nblignes].x1,Lignes[Nblignes].y1,x,y,black); 
	Nblignes++;
	}
    }
}

/* ------------- fonctions redessin aprs event "Expose" ---------- */

void redraw() { int i;
	drawini();
	for (i=0 ; i<Nblignes ; i++)
	   drawvec (	Lignes[i].x1, Lignes[i].y1,
			Lignes[i].x2, Lignes[i].y2, black );
}

/* ---------------------- fonctions initialisation ---------------- */

int drawini() {
	fillrec(0,0,450,400,white);    /* colorier la fen. en blanc */
	drawstr(30,80,"_wid1.c (crit en x=30,y=60)",28,red); /* no comment ! */
	drawvec(30,100,200,150,black); /* vecteur x1,y1--x2,y2 */
}

void iniwid() {
	int b1,b2,b3,cv;

	b1 = initbut (100,10,"aa 11");
	b2 = initbut (210,10,"bb 22");
	b3 = initbut (320,10,"cc 33");
	setbutcbk(b1,&fb1);
	setbutcbk(b2,&fb2);
	setbutcbk(b3,&fb3);

	cv = initcanv (10,150,250,200); /* x,y,lar,hter */
	setcanvcbk(cv , &cvbk);
}
/* --------------------------------- main ------------------------- */
main ()
{
	int event,x,y,key , x0,y0,x1,y1,i;
	char c;
	/* signal (SIGINT, captsig); */

	initfx(450,400);	/* init fentre X, larg 450, hter 400 */
	drawini();		/* dessin initial */
	iniwid();		/* init widgets (buttons) */
	flushfx();		/* vider le buffer X vers l'cran */

	printf("attendre actions souris\n");
	mtkloop ();	/* go in mtk loop - get back only at end */

	exit(EXIT_SUCCESS);
}
