/* wid1.c  exemple xlib : utilise mini-toolkit mtk.c + mx.c
 * compil : 	gcc -c mx.c
 *		gcc -c mtk.c
 * sur linux :	gcc -o wid3 wid3.c mtk.o mx.o -L/usr/X11R6/lib -lX11 -lpthread 
 */

#include <stdio.h>	/* pour printf() */
#include <signal.h>	/* pour signal() */
#include <unistd.h>	/* pour pause() */
#include <stdlib.h>	/* pour EXIT_FAILURE EXIT_SUCCESS */
#include <X11/Xlib.h>	/* pour Expose ButtonPress ... */

#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/uio.h>
#include <signal.h>
#include <unistd.h>
#include <stdio.h>
#include <time.h>
#include <fcntl.h>
#include <errno.h>


#define red     0
#define green   1
#define blue    2
#define yellow  3
#define white   4
#define black   5

extern int larb,htrb;	/* dfinis dans mtk.c */
/*--- structure de donnes pour stocker lignes dessines ---*/
#define N_LIGNES (20)
#define LARGEUR_FENETRE 450
#define RAYON_CERCLE 50
#define TPS_ALRM 1000000

typedef struct { int x1, y1, x2, y2; } Typeligne;
Typeligne Lignes[N_LIGNES];
int Nblignes = -1, gagne=0;
int posCercleX=10, offsetDepl=30;

int deltaTestGagne=10;


/* ------------------------- regarde si le joueur a gagne ------------------- */
int deuxLignesProches(int ind1, int ind2)
{
	ind1 = (ind1)%N_LIGNES;
	ind2 = (ind2)%N_LIGNES;
	int dX = abs(Lignes[ind1].x2 - Lignes[ind2].x1);
	int dY = abs(Lignes[ind1].y2 - Lignes[ind2].y1);
	if((dX <= deltaTestGagne) && (dY <= deltaTestGagne))
		return 1;
	else
		return 0;
}


int testRectangle()
{
	int i, ok=0;
	for(i=0; i<Nblignes-1 && ok==0; i++)
	{
		if( deuxLignesProches(i, i+1) &&
			deuxLignesProches(i+1, i+2) &&
			deuxLignesProches(i+2, i))
				ok = 1;
	}
	return ok;
}


void afficheCercle()
{
	if (gagne)
	{
		fillcerc (posCercleX, 351, RAYON_CERCLE, RAYON_CERCLE, green);
		drawstr(posCercleX+11,380,"Gagn",5,red);
	}
	else
	{
		fillcerc (posCercleX, 351, RAYON_CERCLE, RAYON_CERCLE, red);
	}
	flushfx();
}



/* ------------------------- fonctions callback ------------------- */

void fb1(int ev, int x, int y) {	/* callback for button 1 */
	printf("but1 clicked\n");
	fillrec(15,155,larb,htrb,yellow);
}
void fb2(int ev, int x, int y) {	/* callback for button 2 */
	printf("but2 clicked\n");
	fillrec(15,155,larb,htrb,green);
}
void fb3(int ev, int x, int y) {	/* callback for button 3 */
	printf("but3 clicked - sortir\n");
	fillrec(15,155,larb,htrb,red); flushfx ();
	sleep(2); detruitfx();
	exit(EXIT_SUCCESS);
}
void cvbk(int ev, int x, int y)	/* callback for canvas */
{
    if (ev==ButtonPress) /* only on clic */
    { 
	printf("click in canvas\n");
	Nblignes = (Nblignes+1) % N_LIGNES;
	Lignes[Nblignes].x1 = x;
	Lignes[Nblignes].y1 = y;
	Lignes[Nblignes].x2 = x;
	Lignes[Nblignes].y2 = y;
    }
    else if (ev==MotionNotify) /* when mouse move */
    {
	drawvec(Lignes[Nblignes].x1,Lignes[Nblignes].y1,
		Lignes[Nblignes].x2,Lignes[Nblignes].y2,white);
	Lignes[Nblignes].x2 = x;
	Lignes[Nblignes].y2 = y;
	drawvec(Lignes[Nblignes].x1,Lignes[Nblignes].y1,x,y,black); 
    }
    else if (ev==ButtonRelease) /* when mouse move */
    {
	gagne = testRectangle();
	//afficheCercle();
    }
}

/* ------------- fonctions redessin aprs event "Expose" ---------- */

void redraw()
{
	int i;
	drawini();
	for (i=0 ; i<=Nblignes ; i++)
	   drawvec (	Lignes[i].x1, Lignes[i].y1,
			Lignes[i].x2, Lignes[i].y2, black );
	afficheCercle();
}

/* ---------------------- fonctions initialisation ---------------- */

int drawini()
{
	fillrec(0,0,LARGEUR_FENETRE,400,white);    /* colorier la fen. en blanc */
	drawstr(30,80,"_wid1.c (crit en x=30,y=60)",28,red); /* no comment ! */
	drawvec(30,100,200,150,black); /* vecteur x1,y1--x2,y2 */
}

void iniwid() {
	int b1,b2,b3,cv;

	b1 = initbut (100,10,"aa 11");
	b2 = initbut (210,10,"bb 22");
	b3 = initbut (320,10,"cc 33");
	setbutcbk(b1,&fb1);
	setbutcbk(b2,&fb2);
	setbutcbk(b3,&fb3);

	cv = initcanv (10,150,250,200); /* x,y,lar,hter */
	setcanvcbk(cv , &cvbk);
}


void gestionCercle()
{
	int which = ITIMER_REAL;
	struct itimerval value;

	printf("Timer...\n");

	fillcerc (posCercleX, 351, RAYON_CERCLE, RAYON_CERCLE, white);
	if( ((offsetDepl<0) && (posCercleX<=0)) ||
		((offsetDepl>0) && (posCercleX+RAYON_CERCLE>=LARGEUR_FENETRE)))
			offsetDepl *= -1;
	posCercleX += offsetDepl;
	afficheCercle();

	if (gagne)
	{
		printf("ARRET TIMER\n");
		value.it_interval.tv_sec = 0;
    		value.it_interval.tv_usec = 0;
    		value.it_value.tv_sec = 0;
    		value.it_value.tv_usec = 0;
	        setitimer(which, &value, NULL);
	}

}
/* --------------------------------- main ------------------------- */
main ()
{
	int event,x,y,key , x0,y0,x1,y1,i;
	char c;


/* Gestion des signaux */
    int result = 0;
    struct itimerval value, ovalue, pvalue;
    int which = ITIMER_REAL;
    struct sigaction sact;
    time_t t_deb=time(NULL), t_fin=time(NULL);

    sigemptyset( &sact.sa_mask );
    sact.sa_flags = 0;
    sact.sa_handler = gestionCercle;
    sigaction( SIGALRM, &sact, NULL );
    getitimer( which, &pvalue );

    /*
     * Dfini un timer en millisecondes
     */
    value.it_interval.tv_sec = 0;
    value.it_interval.tv_usec = TPS_ALRM;
    value.it_value.tv_sec = 0;
    value.it_value.tv_usec = TPS_ALRM;

    result = setitimer( which, &value, &ovalue );



	/* Gestion de la fentre */

	initfx(450,400);	/* init fentre X, larg 450, hter 400 */
	drawini();		/* dessin initial */
	iniwid();		/* init widgets (buttons) */
	flushfx();		/* vider le buffer X vers l'cran */

	printf("attendre actions souris\n");
	mtkloop ();	/* go in mtk loop - get back only at end */

	exit(EXIT_SUCCESS);
}
