/* tstmenu3.c    */                      /*I*/
/* exemple toolkit GTK (barre de menus + sous-menu +
 * deuxime barre de menu dtachable ) */	/*i*/
/* UTC UV SR01 - (c) Michel.Vayssade@utc.fr oct 2003
 * compil:
gcc pfc1.c -o pfc1 `gtk-config --cflags --libs`
 */

#include <strings.h>
#include <stdio.h>
#include <gtk/gtk.h>

#define OPEN_F  	1
#define QUITTER 	2
#define A_PROPOS	3
#define AAA	4
#define BBB	5
#define CCC	6
#define BBB_A	7 
#define BBB_B	8 

/* -------------------- Les fonctions callback ----------------- */

/* stupid basic example callback */
static void print_hello( GtkWidget *w, guint data )
{	g_message ("Hello, World!\n");
}
void open_file( GtkWidget *w, guint data ){
	printf("here is open_file callback\n");
	print_hello(w, data);
}
void aaa( GtkWidget *w, guint data ){
	printf("here is aaa callback\n");
	print_hello(w, data);
}
void bbb( GtkWidget *w, guint data ){                 
	printf("here is bbb callback data=%d\n",data);
}
void ccc( GtkWidget *w, guint data ){
	printf("here is ccc callback\n");
}
void quitter( GtkWidget *w, guint data ){
	printf("here is quitter callback\n");
	gtk_main_quit();
}
void apropos( GtkWidget *w, guint data ){
	printf("here is apropos callback\n");
}


/* ------------ Les Traitements des entres de menu ------------ */
void TraiteMenu(GtkWidget *w, guint arg)
{
  switch(arg) 
  {
    case OPEN_F:  	open_file(w,arg); break;
    case AAA:  		aaa(w,arg); break;
    case BBB:  		bbb(w,arg); break;
    case CCC:  		ccc(w,arg); break;
    case QUITTER:  	quitter(w,arg); break;
    case A_PROPOS:	apropos(w,arg); break;
    case BBB_A:		bbb(w,arg); break;  
    case BBB_B:		bbb(w,arg); break;  
  }
}

/* --------------- Le tableau des entres de menu -------------- */

static GtkItemFactoryEntry EntreesDetMenu[] = 		/*I*/
{
  {"/_Fichier",               NULL,         NULL,      0,  "<Branch>"},
  /* nom_menu/entre          raccourci     callback    arg   type  */
  {"/Fichier/Menu_AAA ->aaa", "<control>a", TraiteMenu, AAA, "<Item>"},
  {"/Fichier/Menu_BBB ->bbb", "<control>b", TraiteMenu, BBB, "<Item>"},
/* {"/Fichier/Menu_BBB",       "<control>B", NULL,      0, "<Branch>"},*/
{"/Fichier/Menu_BBB/BBB_A","<control><shift>A",TraiteMenu,BBB_A,"<Item>"},
{"/Fichier/Menu_BBB/BBB_B","<control><shift>B",TraiteMenu,BBB_B,"<Item>"},
  { "/Fichier/sep1",          NULL,         NULL,   0, "<Separator>" },
  {"/Fichier/Menu_CCC ->ccc", "<control>C", TraiteMenu, CCC, "<Item>"},

  {"/Fichier/Quitter",        "<control>Q", TraiteMenu, QUITTER, NULL},
  {"/_Aide",                  NULL,         NULL,   0, "<LastBranch>"},
  {"/Aide/_A propos...",   "<control>H", TraiteMenu,A_PROPOS,"<Item>"}
};

static guint NbEntreesDet = sizeof(EntreesDetMenu) / 
                         sizeof(GtkItemFactoryEntry);	/*i*/

/* -------------- fonction de cration des menus --------------- */

GtkWidget *creer_menu_detach(GtkWidget *Fenetre)		/*I*/
{
  GtkWidget *BarreDetachable;			/*Gg*/
  GtkWidget *DetMenu;
  GtkItemFactory *Fabrique;
  GtkAccelGroup *Raccourcis;

  BarreDetachable = gtk_handle_box_new();

  /* Le groupe de raccourcis de clavier */
  Raccourcis = gtk_accel_group_new();

  /* Cration de la fabrique */
  /* deux fabriques ne doivent pas avoir la mme racine */
  Fabrique = gtk_item_factory_new(GTK_TYPE_MENU_BAR,
                                  "<Main2>",
                                  Raccourcis);
  /* Cration des entres de menus */
  gtk_item_factory_create_items(Fabrique, NbEntreesDet,
                                EntreesDetMenu, NULL);
  gtk_accel_group_attach(Raccourcis, GTK_OBJECT(Fenetre));

  /* On rcupre la barre de menu depuis la fabrique */
  DetMenu = gtk_item_factory_get_widget(Fabrique,
                                          "<Main2>");

  gtk_container_add(GTK_CONTAINER(BarreDetachable), DetMenu);

  return BarreDetachable;
}


/* ------------------------------ main ------------------------ */

int main( int argc, char *argv[] )
{
  GtkWidget *window;
  GtkWidget *main_vbox;
  GtkWidget *menudet;
  
  gtk_init (&argc, &argv);
  
  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_signal_connect (GTK_OBJECT (window), "destroy", 
		      GTK_SIGNAL_FUNC (gtk_main_quit), 
		      "WM destroy");
  gtk_window_set_title (GTK_WINDOW(window), "tstmenu3");
  gtk_widget_set_usize (GTK_WIDGET(window), 300, 200);
  
  main_vbox = gtk_vbox_new (FALSE, 1);
  gtk_container_border_width (GTK_CONTAINER (main_vbox), 0);
  gtk_container_add (GTK_CONTAINER (window), main_vbox);
  
  menudet = creer_menu_detach (window);
  gtk_box_pack_start (GTK_BOX (main_vbox), menudet, FALSE, TRUE, 0);

  gtk_widget_show_all (window);
  gtk_main (); 
  return(0);
}
